Index: XIOS/trunk/src/transformation/transformation_mapping.cpp
===================================================================
--- XIOS/trunk/src/transformation/transformation_mapping.cpp	(revision 624)
+++ XIOS/trunk/src/transformation/transformation_mapping.cpp	(revision 624)
@@ -0,0 +1,182 @@
+/*!
+   \file transformation_mapping.cpp
+   \author Ha NGUYEN
+   \since 14 May 2015
+   \date 18 June 2015
+
+   \brief Take charge of communication among clients to exchange transformed data.
+ */
+
+#include "transformation_mapping.hpp"
+#include <boost/unordered_map.hpp>
+#include "context.hpp"
+#include "context_client.hpp"
+#include "distribution_client.hpp"
+
+namespace xios {
+
+CTransformationMapping::CTransformationMapping(CGrid* destination, CGrid* source)
+  : gridSource_(source), gridDestination_(destination)
+{
+  CContext* context = CContext::getCurrent();
+  CContextClient* client=context->client;
+  int clientRank = client->clientRank;
+
+  CDistributionClient distributionClientSrc(client->clientRank, gridSource_);
+
+  const CArray<size_t,1>& globalIndexGridSrc = distributionClientSrc.getGlobalDataIndexSendToServer(); //gridSource_->getDistributionClient()->getGlobalDataIndexSendToServer();
+  boost::unordered_map<size_t,int> globalIndexOfServer;
+  int globalIndexSize = globalIndexGridSrc.numElements();
+  for (int idx = 0; idx < globalIndexSize; ++idx)
+  {
+    globalIndexOfServer[globalIndexGridSrc(idx)] = clientRank;
+  }
+
+  gridIndexClientClientMapping_ = new CClientServerMappingDistributed(globalIndexOfServer,
+                                                                      client->intraComm,
+                                                                      true);
+}
+
+CTransformationMapping::~CTransformationMapping()
+{
+  if (0 != gridIndexClientClientMapping_) delete gridIndexClientClientMapping_;
+}
+
+/*!
+  Suppose that we have transformations between two grids, which are represented in form of mapping between global indexes of these two grids,
+this function tries to find out which clients a client needs to send and receive these global indexes to accomplish the transformations.
+  The grid destination is the grid whose global indexes demande global indexes from the grid source
+  Grid destination and grid source are also distributed among clients but in different manners.
+  \param [in] globaIndexMapFromDestToSource mapping representing the transformations
+*/
+void CTransformationMapping::computeTransformationMapping(const std::map<size_t, std::set<size_t> >& globaIndexMapFromDestToSource)
+{
+  CContext* context = CContext::getCurrent();
+  CContextClient* client=context->client;
+
+  int numMappingPoints = 0;
+  std::map<size_t, std::set<size_t> >::const_iterator itbMap = globaIndexMapFromDestToSource.begin(), itMap,
+                                                      iteMap = globaIndexMapFromDestToSource.end();
+  for (itMap = itbMap; itMap != iteMap; ++itMap)
+  {
+    numMappingPoints += (itMap->second).size();
+  }
+
+  // All global indexes of a client on grid destination
+  CArray<size_t,1> globalIndexMap(numMappingPoints);
+  // Not only one index on grid destination can demande two indexes from grid source
+  // but an index on grid destination have to be sent to two indexes of grid destination
+  std::map<size_t, std::vector<size_t> > globalIndexMapFromSrcToDest;
+  std::set<size_t>::const_iterator itbSet, itSet, iteSet;
+  int idx = 0;
+  for (itMap = itbMap; itMap != iteMap; ++itMap)
+  {
+    itbSet = (itMap->second).begin();
+    iteSet = (itMap->second).end();
+    for (itSet = itbSet; itSet != iteSet; ++itSet)
+    {
+      globalIndexMap(idx) = *itSet;
+      globalIndexMapFromSrcToDest[*itSet].push_back(itMap->first);
+      ++idx;
+    }
+  }
+
+  // Find out on which clients the necessary indexes of grid source are.
+  gridIndexClientClientMapping_->computeServerIndexMapping(globalIndexMap);
+  const std::map<int, std::vector<size_t> >& globalIndexSentFromGridSource = gridIndexClientClientMapping_->getGlobalIndexOnServer();
+  std::map<int, std::vector<size_t> >::const_iterator itbMapSrc = globalIndexSentFromGridSource.begin(), itMapSrc,
+                                                      iteMapSrc = globalIndexSentFromGridSource.end();
+  std::vector<size_t>::const_iterator itbVec, itVec, iteVec;
+  for (itMapSrc = itbMapSrc; itMapSrc != iteMapSrc; ++itMapSrc)
+  {
+    int sourceRank = itMapSrc->first;
+    itbVec = (itMapSrc->second).begin();
+    iteVec = (itMapSrc->second).end();
+    for (itVec = itbVec; itVec != iteVec; ++itVec)
+    {
+       (globalIndexReceivedOnGridDestMapping_[sourceRank]).push_back(globalIndexMapFromSrcToDest[*itVec]);
+    }
+  }
+
+  // Inform client about the destination to which it needs to send global indexes
+  int nbClient = client->clientSize;
+  int* sendBuff = new int[nbClient];
+  int* recvBuff = new int[nbClient];
+  for (int i = 0; i < nbClient; ++i) sendBuff[i] = 0;
+
+  // First of all, inform the number of destination a client needs to send global index
+  for (itMapSrc = itbMapSrc; itMapSrc != iteMapSrc; ++itMapSrc) sendBuff[itMapSrc->first] = 1;
+  MPI_Allreduce(sendBuff, recvBuff, nbClient, MPI_INT, MPI_SUM, client->intraComm);
+  int numClientToReceive = recvBuff[client->clientRank];
+
+  // Then specify the size of receiving buffer, because we use synch send/receive so only necessary to know maximum size
+  for (itMapSrc = itbMapSrc; itMapSrc != iteMapSrc; ++itMapSrc) sendBuff[itMapSrc->first] = (itMapSrc->second).size();
+  MPI_Allreduce(sendBuff, recvBuff, nbClient, MPI_INT, MPI_MAX, client->intraComm);
+
+  int buffSize = recvBuff[client->clientRank];
+  unsigned long* recvBuffGlobalIndex;
+  if (0 != buffSize) recvBuffGlobalIndex = new unsigned long [buffSize];
+
+  // Inform all "source clients" about index that they need to send
+  for (itMapSrc = itbMapSrc; itMapSrc != iteMapSrc; ++itMapSrc)
+  {
+    MPI_Request request;
+    unsigned long* sendPtr = const_cast<unsigned long*>(&(itMapSrc->second)[0]);
+    MPI_Isend(sendPtr,
+              (itMapSrc->second).size(),
+              MPI_UNSIGNED_LONG,
+              itMapSrc->first,
+              11,
+              client->intraComm,
+              &request);
+  }
+
+  // Now all the "source clients" try listening messages from other "destination clients"
+  int numClientReceived = 0;  // number of client to which data has been already sent
+  int countBuff;
+  while (numClientReceived < numClientToReceive)
+  {
+    MPI_Status status;
+    MPI_Recv(recvBuffGlobalIndex,
+             buffSize,
+             MPI_UNSIGNED_LONG,
+             MPI_ANY_SOURCE,
+             11,
+             client->intraComm,
+             &status);
+
+    MPI_Get_count(&status, MPI_UNSIGNED_LONG, &countBuff);
+    int clientDestRank = status.MPI_SOURCE;
+    for (int idx = 0; idx < countBuff; ++idx)
+    {
+      globalIndexSendToGridDestMapping_[clientDestRank].push_back(recvBuffGlobalIndex[idx]);
+    }
+    ++numClientReceived;
+  }
+
+  delete [] sendBuff;
+  delete [] recvBuff;
+  if (0 != buffSize) delete [] recvBuffGlobalIndex;
+}
+
+/*!
+  Return (grid) global index on grid destination. This mapping contains the rank of client source (that sends info to grid destination)
+and the corresponding global index to write on grid destination.
+  \return global index mapping to receive on grid destination
+*/
+const std::map<int,std::vector<std::vector<size_t> > >& CTransformationMapping::getGlobalIndexReceivedOnGridDestMapping() const
+{
+  return globalIndexReceivedOnGridDestMapping_;
+}
+
+/*!
+  Return (grid) global index on grid source. This mapping contains the rank of client destination (which receives transformation info) and
+the corresponding global index to send
+  \return global index mapping to send on grid source
+*/
+const std::map<int,std::vector<size_t> >& CTransformationMapping::getGlobalIndexSendToGridDestMapping() const
+{
+  return globalIndexSendToGridDestMapping_;
+}
+
+}
Index: XIOS/trunk/src/transformation/transformation_mapping.hpp
===================================================================
--- XIOS/trunk/src/transformation/transformation_mapping.hpp	(revision 624)
+++ XIOS/trunk/src/transformation/transformation_mapping.hpp	(revision 624)
@@ -0,0 +1,52 @@
+/*!
+   \file transformation_mapping.hpp
+   \author Ha NGUYEN
+   \since 14 May 2015
+   \date 09 June 2015
+
+   \brief Take charge of communication among clients to exchange transformed data.
+ */
+#ifndef __XIOS_TRANSFORMATION_MAPPING_HPP__
+#define __XIOS_TRANSFORMATION_MAPPING_HPP__
+
+#include <map>
+#include <set>
+#include "grid.hpp"
+#include "array_new.hpp"
+#include "client_server_mapping_distributed.hpp"
+
+namespace xios {
+
+/*!
+  \class CTransformationMapping
+  This class is in charge of transfer the global index form grid from grid source to grid destination in a rather generic way.
+In order to make a transformation, the grid destination will make a request to grid source about the global indexes which it needs.
+The same discovering algorithm as the case of client-server is applied to find the corresponding client which contains the demanding global index.
+*/
+class CTransformationMapping
+{
+public:
+  /** Default constructor */
+  CTransformationMapping(CGrid* destination, CGrid* source);
+  ~CTransformationMapping();
+
+  void computeTransformationMapping(const std::map<size_t, std::set<size_t> >& globaIndexMapFromDestToSource);
+  const std::map<int,std::vector<std::vector<size_t> > >& getGlobalIndexReceivedOnGridDestMapping() const;
+  const std::map<int,std::vector<size_t> >& getGlobalIndexSendToGridDestMapping() const;
+
+protected:
+  CGrid* gridSource_;  // Grid source
+  CGrid* gridDestination_; // Grid destination demande the necessary global index from grid source
+
+  //! Global index mapping of grid source and grid destination between two clients
+  CClientServerMappingDistributed* gridIndexClientClientMapping_;
+
+  //! Mapping of client rank of grid source and global index received in grid destination
+  std::map<int,std::vector<std::vector<size_t> > > globalIndexReceivedOnGridDestMapping_;
+
+  //! Mapping of client rank of grid destination and global index to send from grid source
+  std::map<int,std::vector<size_t> > globalIndexSendToGridDestMapping_;
+};
+
+}
+#endif // __XIOS_TRANSFORMATION_MAPPING_HPP__
